SystemOrganization addCategory: #'Objetos3SelfModification-Tests'!

Object subclass: #Example1
	instanceVariableNames: 'v2 v1'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Objetos3SelfModification-Tests'!

!Example1 methodsFor: 'as yet unclassified' stamp: 'Sawady 11/7/2012 01:11'!
m1
^'m1'! !

!Example1 methodsFor: 'as yet unclassified' stamp: 'jh 10/23/2012 14:12'!
m2
^'m2'! !

Object subclass: #Example2
	instanceVariableNames: 'v3 v1'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Objetos3SelfModification-Tests'!

!Example2 methodsFor: 'as yet unclassified' stamp: 'Sawady 11/7/2012 01:11'!
m1
^'m1'! !

!Example2 methodsFor: 'as yet unclassified' stamp: 'jh 10/23/2012 14:12'!
m3
^'m3'! !

TestCase subclass: #ClassDiffTest
	instanceVariableNames: 'classDiff'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Objetos3SelfModification-Tests'!

!ClassDiffTest methodsFor: 'accessing' stamp: 'Sawady 10/27/2012 08:08'!
classDiff
	^ classDiff! !

!ClassDiffTest methodsFor: 'accessing' stamp: 'Sawady 10/27/2012 08:08'!
classDiff: anObject
	classDiff := anObject! !

!ClassDiffTest methodsFor: 'tests' stamp: 'Sawady 11/7/2012 00:54'!
setUp

classDiff := ClassDiff commonSuperClass: 'ExampleSuper' class1: Example1 class2: Example2! !

!ClassDiffTest methodsFor: 'tests' stamp: 'Sawady 11/7/2012 01:11'!
testExecute

self classDiff execute.

[
self assert: (Example1 superclass asString = 'ExampleSuper').
self assert: (Example2 superclass asString = 'ExampleSuper').

self deny: (Example1 instVarNames includes: 'v1').
self deny: (Example2 instVarNames includes: 'v1').
self assert: (Example1 superclass instVarNames includes: 'v1').

self deny: (Example1 methodDictionary keys includes: #m1).
self deny: (Example2 methodDictionary keys includes: #m1).
self assert: (Example1 superclass methodDictionary keys includes: #m1).

] ensure: [self classDiff undo]! !

TestCase subclass: #PullUpDiffMethodsTest
	instanceVariableNames: 'refactor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Objetos3SelfModification-Tests'!

!PullUpDiffMethodsTest methodsFor: 'tests' stamp: 'Sawady 11/7/2012 00:42'!
setUp

refactor := PullUpDiffMethods class1: Example1 class2: Example2.! !

!PullUpDiffMethodsTest methodsFor: 'tests' stamp: 'Sawady 11/7/2012 00:42'!
testGetMethodDiffBetweenClasses
	"Tests ClassDiff>>#getMethodDiffBetweenClasses"
	| methodDict |
	methodDict := refactor getMethodDiffBetweenClasses.

	self assert: ( methodDict size = 1).
	self assert: ( methodDict keys includesAllOf: (Set with: #m1)).! !

TestCase subclass: #PullUpDiffVarsTest
	instanceVariableNames: 'refactor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Objetos3SelfModification-Tests'!

!PullUpDiffVarsTest methodsFor: 'tests' stamp: 'Sawady 11/7/2012 00:46'!
setUp

refactor := PullUpDiffVars class1: Example1 class2: Example2.! !

!PullUpDiffVarsTest methodsFor: 'tests' stamp: 'Sawady 11/7/2012 00:45'!
testGetVarDiffBetweenClasses
	"Tests ClassDiffs>>#getVarDiffBetweenClasses"
	| varDiff |
	varDiff := refactor getVarDiffBetweenClasses.
	self assert: varDiff size = 1.
	self assert: (varDiff includesAllOf: (Set with: 'v1'))! !
